<template>
  <div class="filters-group ds">
    <div class="">
      <search-bar :config="config" />
      <div class="ec-search-result">
        <div class="row margin-0-mobile flex-column flex-md-row ">
          <search-count :config="config" />
          <search-api-link :config="config" />
          <search-sort-dropdown :config="config" />
        </div>
        <hr class="d-none d-md-block" />

        <!-- ADVANCED SEARCH SPECIAL FILTERS (to be moved to a separate component) -->
        <!-- Search in -->
        <div class="advanced-search-filters">
        <span v-if="searchInTitle" class="search-in">
          Search in Title
         
            <svg @click="clearQuery" xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-x close-facet"
              viewBox="0 0 16 16">
              <path
                d="M4.646 4.646a.5.5 0 0 1 .708 0L8 7.293l2.646-2.647a.5.5 0 0 1 .708.708L8.707 8l2.647 2.646a.5.5 0 0 1-.708.708L8 8.707l-2.646 2.647a.5.5 0 0 1-.708-.708L7.293 8 4.646 5.354a.5.5 0 0 1 0-.708" />
            </svg>
       
        </span>

        <span v-if="searchInDesc" class="search-in">
          Search in Description
      
          <svg @click="clearQuery" xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor"
            class="bi bi-x close-facet" viewBox="0 0 16 16">
            <path
              d="M4.646 4.646a.5.5 0 0 1 .708 0L8 7.293l2.646-2.647a.5.5 0 0 1 .708.708L8.707 8l2.647 2.646a.5.5 0 0 1-.708.708L8 8.707l-2.646 2.647a.5.5 0 0 1-.708-.708L7.293 8 4.646 5.354a.5.5 0 0 1 0-.708" />
          </svg>
    
        </span>

        </div>

        <!-- DATE -->



      </div>
    </div>
  </div>
</template>

<script>
import SearchBar from "@/components/search/search-filters/SearchBar";
import SearchCount from "@/components/search/search-filters/SearchCount";
import SearchApiLink from "@/components/search/search-filters/SearchApiLink";
import SearchSortDropdown from "@/components/search/search-filters/SearchSortDropdown";

export default {
  name: "SearchFilters",
  data() {
    return {
      searchInTitle: false,
      searchInDesc: false,
    }
  },
  components: {
    SearchSortDropdown,
    SearchApiLink,
    SearchCount,
    SearchBar
  },
  props: {
    config: Object
  },
  computed: {
    getFacets() {
      return this.$store.getters[`${this.config.getFacets[0]}/${this.config.getFacets[1]}`];
    }
  },
  methods: {
    clearQuery() {

      // CLEAR FUNCTION NEEDS TO BE DONE RIGHt!!!!
      // it is not clearing completly
      // FIELDS wird immernoch honzugefügt zur URL

  

      this.query = ''; // Clear the input field
      this.searchInDesc = false;
      this.searchInTitle = false;
      sessionStorage.setItem('titleQuery', '');
      sessionStorage.setItem('descQuery', '');
      sessionStorage.setItem('query', '');

      // Remove 'query' and 'fields' parameters from the URL
      const url = new URL(window.location.href);
      const params = new URLSearchParams(url.search);

      params.delete('query');
      if (params.has('fields') && params.get('fields').startsWith('title.')) {
        params.delete('fields');
      } else if (params.has('fields') && params.get('fields').startsWith('description.')) {
        params.delete('fields');
      }

      // Update the URL without reloading the page
      window.history.replaceState({}, '', `${url.pathname}?${params.toString()}`);
      
      // TRIGGER HERE the ParamterCount!!!!

      // Hacky solution:
      // window.location.reload();
    },
    checkUrlParameters() {
      const urlParams = new URLSearchParams(window.location.search);

      // Check if "fields=title.*" is in the URL
      if (urlParams.has('fields') && urlParams.get('fields').startsWith('title.')) {
        this.searchInTitle = true;
      } else if (urlParams.has('fields') && urlParams.get('fields').startsWith('description.')) {
        this.searchInDesc = true;
      }
    },
  },
  created() {
    this.checkUrlParameters();
  }
};
</script>

<style lang="scss" scoped>

.advanced-search-filters {
  display: flex;
  flex-wrap: wrap;
  justify-content: flex-start;
  align-items: center;
  gap: 10px;
  margin-bottom: 10px;
  margin-left: 20px;
}
.search-in {

  background-color: #515560 !important;
  color: #fff !important;
  padding: 6px 10px 5px 10px !important;
  font-size: 14px;
  font-weight: 100;
  border-radius: 30px;
}

.close-facet {
  cursor: pointer;
}
@media screen and (max-width: 767.5px) {
  .margin-0-mobile {
    margin: 0;
  }
}
</style>
